package aufgabe5;

/**
 * Generic test class defining an elephant
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Elephant extends Tier {

    public Elephant() {
        super(4, "elephanten grau");
    }

    /**
     * Trumpet for a certain amount of duration through which sth. is printed to System.out.
     * The precision of timing is up to milliseconds.
     * @param dauer duration to trumpet in seconds
     */
    public void trompeten(double dauer) {
        var start = System.currentTimeMillis();
        // convert dauer from seconds to milliseconds
        var duration = (int) (dauer * 1e3);

        while(System.currentTimeMillis() - start < duration) {
            System.out.println("törööööööööööööö");
        }
    }
}
