package aufgabe5;

/**
 * Generic test class defining a cage for animals
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
@SuppressWarnings("unused")
public class Gehege {
    /**
     * How many animals fit in the cage
     */
    private int kapazitaet;
    /**
     * Size of the cage in square meters
     */
    private final double groesse;

    public Gehege(int kapazitaet, double groesse) {
        this.kapazitaet = kapazitaet;
        this.groesse = groesse;
    }

    /**
     * Add a new animal to the cage.
     * @post increments capacity
     * @param animal the animal to add
     */
    public void addTier(Tier animal) {
        System.out.println("added animal " + animal);
    }

    /**
     * Remove an animal to the cage.
     * @post decrements capacity
     * @param animal the animal to remove
     */
    public void removeTier(Tier animal) {
        System.out.println("removed animal " + animal);
    }

    /**
     * Feeds the animals of this cage.
     * Does effectively nothing.
     */
    public void tiereFuettern() {
        // feed the animals in some way cuz we don't know the exact animals in the cage
        System.out.println("feeded animals");
    }
}
