package aufgabe6;

/**
 * Generic test class defining a double winged airplane
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
@SuppressWarnings("unused")
public final class Doppeldecker extends Flugzeug {

    /**
     * Minimum speed to fly a looping in km/s
     */
    public static final double LOOPING_SPEED = 320;

    private final boolean offenesCockpit;

    public Doppeldecker(String hersteller, int maxSpeed, String immatrikulationNumber, boolean offenesCockpit) {
        super(hersteller, maxSpeed, 2);
        setImmatNummer(immatrikulationNumber);
        this.offenesCockpit = offenesCockpit;
    }

    public Doppeldecker(String hersteller, int maxSpeed, String immatrikulationNumber) {
        super(hersteller, maxSpeed, 2);
        setImmatNummer(immatrikulationNumber);
        this.offenesCockpit = true;
    }

    /**
     * whether the plane as an open cockpit
     * @return whether the plane as an open cockpit
     */
    public boolean isOffenesCockpit() {
        return offenesCockpit;
    }

    /**
     * @return if this plane can fly a looping
     */
    @Override
    public boolean getLooping() {
        return getMaxSpeed() > LOOPING_SPEED;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Doppeldecker plane) {
            return super.equals(obj) && plane.offenesCockpit == this.offenesCockpit;
        }

        return false;
    }
}
