package aufgabe6;

/**
 * Generic test class defining a passenger airplane
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
@SuppressWarnings("unused")
public class Verkehrsflugzeug extends Flugzeug {

    private int passangers;

    public Verkehrsflugzeug(String hersteller, int maxSpeed, String immatrikulationNumber, int passangers) {
        super(hersteller, maxSpeed, 1);
        this.passangers = passangers;
        this.setImmatNummer(immatrikulationNumber);
    }

    /**
     * @return the number of passengers
     */
    public int getAnzahlPassagiere() {
        return passangers;
    }

    /**
     * Set the number of passengers
     * @post alters the amount of passengers
     * @param passengers the new amount of passengers
     */
    public void setPassangers(int passengers) {
        this.passangers = passengers;
    }

    /**
     * @return if this plane can fly a looping
     */
    @Override
    public final boolean getLooping() {
        return false;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Verkehrsflugzeug plane) {
            return super.equals(obj) && plane.getAnzahlPassagiere() == this.passangers;
        }

        return false;
    }
}
