/**
 * Generic test class for implementing and testing
 * custom minimum and maximum methods
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe3 {

    /**
     * compute the maximum of a and b
     * @apiNote prints the result ot System.out
     * @param a the first value to compute the maximum of
     * @param b the second value to compute the maximum of
     * @return the maximum of the two values
     */
    private static int max(int a, int b) {
        int max = a > b ? a : b;
        System.out.println("max: " + max);
        return max;
    }

    /**
     * Compute the maximum of a and b
     * @param a the first value to compute the maximum of
     * @param b the second value to compute the maximum of
     * @param c the third value to compute the maximum of
     * @return the maximum of the values
     */
    private static int max(int a, int b, int c) {
        if (a < b) {
            return b > c ? c : a;
        }
        return a > c ? a : c;
    }

    /**
     * Compute the minimum of a and b
     * @param a the first value to compute the minimum of
     * @param b the second value to compute the minimum of
     * @param c the third value to compute the minimum of
     * @return the minimum of the values
     */
    private static double max(double a, double b, double c) {
        if (a < b) {
            return b > c ? c : a;
        }
        return a > c ? a : c;
    }

    public static void main(String[] args) {
        System.out.println(max(2, 3));
        System.out.println(max(5, 49, -3));
        System.out.println(max(0.2345, Math.PI, 99.23));
    }
}