import org.junit.Test;

import static junit.framework.TestCase.*;

/**
 * Generic test class for implementing and testing
 * a simple boolean majority function
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe4 {

    /**
     * Returns true if at least one of the parameters is true
     * @param a
     * @param b
     * @param c
     * @return the bitwise OR of the parameters
     */
    private static boolean majority(boolean a, boolean b, boolean c) {
        return a || b || c;
    }

    @Test
    public void test() {
        assertTrue(majority(true, true, true));
        assertTrue(majority(true, false, true));
        assertTrue(majority(true, true, false));
        assertTrue(majority(true, false, false));
        assertFalse(majority(false, false, false));
    }
}
