/**
 * Generic test class for implementing and testing
 * a basic Konto
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe7 {

    private double guthaben;

    /**
     * Get some money from the konto.
     * If the betrag is less than the money contained by the konto,
     * then the maximum possible amount is taken from the konto and a message is printed
     * to System.out
     * @param betrag the amount of money to get out of the konto
     */
    public void abheben(double betrag) {
        var neuesGuthaben = guthaben - betrag;
        if (neuesGuthaben < 0) {
            System.out.println("Sie konnten nur " + guthaben + " abheben");
            this.guthaben = 0;
            return;
        }
        guthaben = neuesGuthaben;
    }

    /**
     * Put some money in the konto.
     * @exception IllegalArgumentException When betrag is negative
     * @param betrag the amount of money to add to the konto
     */
    public void einzahlen(double betrag) {
        if (betrag < 0) {
            throw new IllegalArgumentException("Man kann keinen negativen Betrag einzahlen");
        }
        this.guthaben += betrag;
    }

    /**
     * Get the amount of memory in the konto
     * @return the amount of memory in the konto
     */
    public double getGuthaben() {
        return guthaben;
    }

    public static void main(String[] args) {
        var konto = new Aufgabe7();

        konto.einzahlen(134);
        konto.einzahlen(0.345);
        System.out.println("Guthaben: " + konto.getGuthaben());
        konto.abheben(1e6);
    }
}
