import org.junit.Test;

/**
 * Generic test class for implementing and testing repeating strings
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe2 {

    /**
     * Repeat the supplied character by a given number
     * @param symbol the character to repeat
     * @param number number of repetitions
     * @return the repeated characters as string
     */
    private static String repeat(char symbol, int number) {
        if (number == 0) {
            return String.valueOf(symbol);
        }
        return symbol + repeat(symbol, number - 1);
    }

    @Test
    public void test() {
        var result = repeat('a', 78);
        System.out.println(result);
    }
}
