import org.junit.Test;

import static junit.framework.TestCase.assertEquals;

/**
 * Generic test class for implementing and testing fibonacci algorithms
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe3 {
    /**
     * calculate the fibonacci value of any given element by recursion
     * @param x the index of the fibonacci sequence
     * @return the fibonacci value for the given index
     */
    private static int fibonacciRecursive(int x) {
        return x < 2 ? x : fibonacciRecursive(x - 1) + fibonacciRecursive(x - 2);
    }

    /**
     * calculate the fibonacci value of any given element by iteration
     * @param x the index of the fibonacci sequence
     * @return the fibonacci value for the given index
     */
    private static int fibonacciIterative(int x) {
        int sum = 0;
        int sum2 = 1;

        for (int y = 0; y < (x - 1); y++)  {
            int t = sum;
            sum = sum2;
            sum2 = t + sum;
        }
        return sum2;
    }

    @Test
    public void test() {
        System.out.println("recursive: " + fibonacciRecursive(7));
        System.out.println("iterative: " + fibonacciIterative(7));

        assertEquals(fibonacciRecursive(7), fibonacciIterative(7));
        assertEquals(fibonacciRecursive(68), fibonacciIterative(68));
        assertEquals(fibonacciRecursive(13), fibonacciIterative(13));
    }
}
