import org.junit.Test;

import static junit.framework.TestCase.assertEquals;

/**
 * Generic test class for implementing and testing an algorithm to reverse strings
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe4 {

    /**
     * Dreht ein übergebenes Wort um und gibt das Ergebnis
     * als einen neuen String zurück.
     * Beispiel: Bei dem Argument "katze" ist die Rückgabe "eztak".
     *
     * @pre wort != null und mindestens 1 Zeichen lang.
     * @param wort Wort, das umgedreht werden soll.
     * @return Umgedrehtes Wort.
     */
    public static String dreheWortUm(String wort) {
        if (wort.length() < 2) {
            return wort;
        }
        return dreheWortUm(wort.substring(1)) + wort.charAt(0);
    }

    @Test
    public void test() {
        assertEquals(dreheWortUm("abcdefghijklmnopqrstuvwxyz"), "zyxwvutsrqponmlkjihgfedcba");
    }
}
