import java.util.Scanner;

/**
 * Generic test class for implementing and testing listing all permutations of a given number of characters
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe6 {

    /**
     * Print all permutations of every character from the beginning of the alphabet to the N-th character
     * @param n the index of the highest character to use
     */
    private static void printPermutations(int n) {
        if (n < 0  || n > 26) {
            throw new IllegalArgumentException("N must be between 0 and 26");
        }

        final var LOOKUP = "abcdefghijklmnopqrstuvwxyz";

        for (int i = 0; i < n; i++) {

            var builder = new StringBuilder();
            // rotate characters
            for (int k = 0; k < n; k++) {
                var idx = (i + k) % n;
                builder.append(LOOKUP.charAt(idx));
            }
            System.out.println(builder);

            // reverse rotated characters
            builder.reverse();

            System.out.println(builder);
        }
    }

    public static void main(String[] args) {
        try(var scanner = new Scanner(System.in)) {
            var n = scanner.nextInt(10);

            printPermutations(n);
        }
    }
}
