import org.junit.Test;

/**
 * Generic test class for implementing and testing an algorithm to compare two arrays as array of pairs
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe7 {

    /**
     * Test if the two arrays are filled with the same pair
     *
     * @param x the first value of each pair
     * @param y the second value of each pair
     * @return if the two arrays contain the same pair
     */
    private static boolean eq(int[] x, int[] y) {
        if (x.length != y.length)
            return false;

        for (int i = 0; i < x.length; i++) {
            var x2 = x[i];
            var y2 = y[i];

            for (int j = 0; j < y.length; j++) {
                if (x2 != x[j] || y2 != y[j])
                    return false;
            }
        }

        return true;
    }

    @Test
    public void test() {
        int x []= {9,8,7,6,5,4};
        int y []= {1,2,3,4,5,6};

        System.out.println(eq(x, y));
    }
}
