import org.junit.Test;

import java.util.Arrays;

/**
 * Generic test class for implementing and testing an algorithm to reverse arrays of strings
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe9 {

    /**
     * Creates a new instance of the supplied strings and returns the reversed array
     * @param strings the array of strings to reverse
     * @return the reversed array instance
     */
    private static String[] reverse1(String[] strings) {
        var result = new String[strings.length];

        for (int i = 0; i < result.length; i++) {
            result[strings.length - i - 1] = strings[i];
        }

        return result;
    }

    /**
     * Reverse the supplied array
     * @param strings the array of strings to reverse
     */
    private static void reverse2(String[] strings) {

        for (int i = 0; i < strings.length / 2; i++) {
            var tmp = strings[i];
            strings[i] = strings[strings.length - i - 1];
            strings[strings.length - i - 1] = tmp;
        }
    }

    @Test
    public void test() {
        var STRINGS = new String[] {
                "abc",
                "def",
                "ghi",
                "123",
                "456",
                "789"
        };

        System.out.println(Arrays.toString(reverse1(STRINGS)) + " " + Arrays.toString(STRINGS));

        reverse2(STRINGS);
        System.out.println(Arrays.toString(STRINGS));
    }
}
