import org.junit.Test;

import java.util.Arrays;

import static org.junit.Assert.assertEquals;

/**
 * Generic test class for implementing and testing finding the largest element^ of an integer array
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe1 {

    /**
     * Returns the largest integer value from the supplied array.
     * @param array the array to search through
     * @return the largest integer value from the supplied array
     * @apiNote The largest element is searched in parallel through Stream API.
     */
    public static int findLargestThingy(int[] array) {
        return Arrays.stream(array).parallel().max().orElseThrow();
    }

    @Test
    public void test() {
        final var ARRAY = new int[] {
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
        };

        assertEquals(findLargestThingy(ARRAY), 12);
    }

    ////////////////////////////////
    // Task b)
    ////////////////////////////////

    private int[] test;
    private int erg;

    @Test
    public void findeGroesstes() {
        test = new int[] { 5, 4, 6, 1 };
        erg = 6;
        assertEquals(erg, Aufgabe1.findLargestThingy(test));
        test = new int[] { 2133231234, 6213123, 1012312, 4353453, 123123127, 4563564 };
        erg = test[0];
        assertEquals(erg, Aufgabe1.findLargestThingy(test));
    }
}
