import org.junit.Test;

import java.util.Arrays;

import static org.junit.Assert.assertTrue;

/**
 * Generic test class for implementing and testing swapping elements of an array
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe2 {

    /**
     * Swap the values of the given indices of the given array
     * @param a the array to swap elements of
     * @param idx first index
     * @param idy second index
     */
    private static void swapIndices(int[] a, int idx, int idy) {
        var tmp = a[idx];
        a[idx] = a[idy];
        a[idy] = tmp;
    }

    @Test
    public void test() {
        var array = new int[] {1, 2, 3, 4, 5};

        swapIndices(array, 0, 1);
        swapIndices(array, 1, 2);
        swapIndices(array, 2, 0);
        swapIndices(array, 4, 2);

        assertTrue(Arrays.equals(array, new int[] {1, 3, 5, 4, 2}));
    }
}
