import org.junit.Test;
import java.util.Scanner;

/**
 * Generic test class for implementing and testing the fizzbuzz game
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Aufgabe4 {

    /**
     * Returns "fizz" if x is divisible by 3
     * and "buzz" if x is divisible by 5
     * and "fizzbuzz" if x is divisible by 3 and 5
     * else return x as string
     * @param x the number to play fizzbuzz with
     * @return the fizzbuzz string
     */
    private static String fizzbuzz(int x) {
        var divisibleBy3 = (x % 3) == 0;
        var divisibleBy5 = (x % 5) == 0;

        if (divisibleBy3 && divisibleBy5) {
            return "FizzBuzz";
        } else if (divisibleBy3) {
            return "Fizz";
        } else if (divisibleBy5) {
            return "Buzz";
        }

        return String.valueOf(x);
    }

    /**
     * Play fizz buzz.
     * Reads numbers from System.in and prints the according fizzbuzz string.
     * @apiNote this function blocks the current thread until 0 is read from System.in
     */
    private static void playFizzBuzz() {
        try(var scanner = new Scanner(System.in)) {
            var number = scanner.nextInt();

            if (number == 0) {
                return;
            }

            System.out.println(fizzbuzz(number));
        }
    }

     @Test
    public void testFizzBuzz() {
        playFizzBuzz();
     }
}
