package aufgabe2;

/**
 * Generic test class for implementing dynamic string arrays
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class DynamicStringArray {
    // actual number of elements stored in the array
    private int size = 0;
    private String[] array = new String[2];

    /**
     * Adds a new string to the array.
     * Reallocate the array if the size is reached.
     * @param next the element to append
     */
    public void add(String next) {
        // test if we need to reallocate
        if (array.length == size) {
            // temporarily store input strings
            String[] inputStringsTemp = array;

            // double input strings size
            var capacity = array.length * 2;

            array = new String[capacity];

            // copy original input strings into double sized strings
            System.arraycopy(inputStringsTemp, 0, array, 0, size);
        }
        // store new element into increased array
        array[size++] = next;
    }

    /**
     * the number of elements stored
     * @return amount of stored strings
     */
    public int length() {
        return size;
    }

    /**
     * fetch an element at index i
     * @param i the index to fetch
     * @return the element at index i
     */
    public String get(int i) {
        return array[i];
    }
}