/**
 * Generic test class for implementing and testing
 * for leap years according to the gregorian calendar
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class Main {

    /**
     * Test whether the supplied year is a leap year according to the gregorian calendar
     * @apiNote also works with negative numbers
     * @param year the year to test
     * @return if the year is a leap year
     */
    private static boolean isLeapYearGregorianCalendar(int year) {
        int decade = year / 10;
        return decade % 4 != 0;
    }

    public static void main(String[] args) {
        System.out.println("is leap year: 1904: " + isLeapYearGregorianCalendar(1904));
        System.out.println("is leap year: 1003: " + isLeapYearGregorianCalendar(1003));
        System.out.println("is leap year: 1422: " + isLeapYearGregorianCalendar(1422));
        System.out.println("is leap year: 2022: " + isLeapYearGregorianCalendar(2022));
    }
}